/*
 * GGG4J.java
 *
 * Created on 2005/07/01, 18:39
 * Copyright 2005 Takeshi Yoneki / OSTRA / OSTRACISM CO., All rights reserved.
 */

package jp.maccreators.ostra.ggg4j;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Point;
import java.util.List;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.util.ArrayList;
import javax.swing.JFrame;
import java.awt.dnd.DropTargetListener;
import java.awt.dnd.DropTargetAdapter;
import java.awt.dnd.DropTargetDropEvent;
import java.io.File;
import javax.swing.JOptionPane;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

/**
 * CEBhENX
 * @author	ostra
 */
public class GGG4J extends javax.swing.JFrame {
	final static String m_versionString = "GraphicGripGrop 1.0.1";
	TGraphicSearch m_gs = null;
	ArrayList m_hits = new ArrayList();
	TSetting m_setting = null;
	TSetting m_settingSaved = null;
	public final static String m_bundlePath = "jp/maccreators/ostra/ggg4j/Resource";
	
	/** Creates new form GGG4J */
	public GGG4J() {
		initComponents();
		
		/*
		 * e[uf
		 */

		TableModel dataModel = new AbstractTableModel() {
			public int getColumnCount() {
				return 2;
			}
			public int getRowCount() {
				return m_hits.size();
			}
			public String getColumnName(int column) {
				if (column == 0)
					return java.util.ResourceBundle.getBundle(m_bundlePath).getString("columnMatchRate");
				else if (column == 1)
					return java.util.ResourceBundle.getBundle(m_bundlePath).getString("columnFilePath");
				return "";
			}
			public Object getValueAt(int row, int col) {
				if (row >= m_hits.size())
					return null;
				TFileInfo info = (TFileInfo)m_hits.get(row);
				if (info == null)
					return null;
				if (col == 0)
					return new Long(info.m_matchRate);
				else if (col == 1)
					return info.m_filePath;
				return null;
			}
		};
		tblResult.setModel(dataModel);
		tblResult.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_LAST_COLUMN);
		tblResult.getColumnModel().getColumn(0).setPreferredWidth(50);
		tblResult.getColumnModel().getColumn(1).setPreferredWidth(500);
		
		/*
		 * hbOhbv
		 */

		DropTargetListener dtl = new DropTargetAdapter() {
			//public Component context;
			public void drop(DropTargetDropEvent dtde) {
				dtde.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);
				List list = null;
				try {
					DataFlavor[] df = dtde.getCurrentDataFlavors();
					Transferable t = dtde.getTransferable();
					list = (List)t.getTransferData(DataFlavor.javaFileListFlavor);
					for (int i = 0; list != null && i < list.size(); i++) {
						File f = (File)list.get(i);
						if (f.isDirectory()) {
							m_gs.m_topDirPath = f.getPath();
						}
						else if (f.isFile()) {
							if (m_gs.checkIndexFile(f.getPath()))
								m_gs.m_indexFilePath = f.getPath();
							else
								m_gs.m_target.m_filePath = f.getPath();
						}
					}
				}
				catch (Exception e) {
				}
				dtde.dropComplete(true);
			}
		};
		this.setDropTarget(new DropTarget(this, dtl));
		tblResult.setDropTarget(new DropTarget(tblResult, dtl));
		btnSearch.setDropTarget(new DropTarget(btnSearch, dtl));
		
		m_setting = new TSetting();
		if (m_setting.beginning())
			m_settingSaved = m_setting.getClone();
		m_gs = new TGraphicSearch();
		m_gs.loadSetting(m_setting);
		m_gs.m_parentWindow = this;

		/*
		 * R[obN
		 */

		m_gs.m_context = new TGraphicSearch.Callback() {
			public void hitItemCallback(TFileInfo info) {
				m_hits.add(info);
				tblResult.revalidate();
			}

			public void progressCallback(TFileInfo info) {
				msgCurrentFilePath.setText(info.m_filePath);
				msgCurrentFilePath.revalidate();
			}

			public void searchEndCallback() {
				msgCurrentFilePath.setText("");
				msgCurrentFilePath.revalidate();
		        btnSearch.setText(java.util.ResourceBundle.getBundle(m_bundlePath).getString("btnSearch"));
			}
		};

		this.setLocation(m_setting.locationX, m_setting.locationY);
		this.setSize(m_setting.windowWidth, m_setting.windowHeight);
	}
	
	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
    // <editor-fold defaultstate="collapsed" desc=" ꂽR[h">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        btnSearch = new javax.swing.JButton();
        msgCurrentFilePath = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tblResult = new javax.swing.JTable();
        menuBarMain = new javax.swing.JMenuBar();
        menuFile = new javax.swing.JMenu();
        menuCreateIndexFile = new javax.swing.JMenuItem();
        menuOpenGraphicFile = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        menuExit = new javax.swing.JMenuItem();
        menuCommand = new javax.swing.JMenu();
        menuSearch = new javax.swing.JMenuItem();
        menuStop = new javax.swing.JMenuItem();
        menuHelp = new javax.swing.JMenu();
        menuVersion = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("GraphicGripGrop");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                onClosing(evt);
            }
        });

        jPanel1.setLayout(new java.awt.BorderLayout(0, 5));

        jPanel2.setLayout(new java.awt.BorderLayout());

        jPanel2.setPreferredSize(new java.awt.Dimension(10, 31));
        jPanel4.setPreferredSize(new java.awt.Dimension(5, 10));
        jPanel2.add(jPanel4, java.awt.BorderLayout.WEST);

        jPanel5.setPreferredSize(new java.awt.Dimension(5, 10));
        jPanel2.add(jPanel5, java.awt.BorderLayout.EAST);

        jPanel6.setLayout(new java.awt.BorderLayout(5, 0));

        jPanel6.setPreferredSize(new java.awt.Dimension(10, 26));
        btnSearch.setText(java.util.ResourceBundle.getBundle("jp/maccreators/ostra/ggg4j/Resource").getString("btnSearch"));
        btnSearch.setMaximumSize(new java.awt.Dimension(80, 23));
        btnSearch.setMinimumSize(new java.awt.Dimension(80, 23));
        btnSearch.setPreferredSize(new java.awt.Dimension(80, 23));
        btnSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSearchActionPerformed(evt);
            }
        });

        jPanel6.add(btnSearch, java.awt.BorderLayout.WEST);

        msgCurrentFilePath.setEditable(false);
        jPanel6.add(msgCurrentFilePath, java.awt.BorderLayout.CENTER);

        jPanel2.add(jPanel6, java.awt.BorderLayout.CENTER);

        jPanel3.setPreferredSize(new java.awt.Dimension(10, 5));
        jPanel2.add(jPanel3, java.awt.BorderLayout.NORTH);

        jPanel1.add(jPanel2, java.awt.BorderLayout.NORTH);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(400, 200));
        tblResult.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Match Rate", "File Path"
            }
        ));
        tblResult.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                onTblResultMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(tblResult);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        menuFile.setText(java.util.ResourceBundle.getBundle("jp/maccreators/ostra/ggg4j/Resource").getString("menuFile"));
        menuCreateIndexFile.setText(java.util.ResourceBundle.getBundle("jp/maccreators/ostra/ggg4j/Resource").getString("menuCreateIndexFile"));
        menuCreateIndexFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuCreateIndexFileActionPerformed(evt);
            }
        });

        menuFile.add(menuCreateIndexFile);

        menuOpenGraphicFile.setText(java.util.ResourceBundle.getBundle("jp/maccreators/ostra/ggg4j/Resource").getString("menuOpenGraphicFile"));
        menuOpenGraphicFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuOpenGraphicFileActionPerformed(evt);
            }
        });

        menuFile.add(menuOpenGraphicFile);

        menuFile.add(jSeparator1);

        menuExit.setText(java.util.ResourceBundle.getBundle("jp/maccreators/ostra/ggg4j/Resource").getString("menuExit"));
        menuExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuExitActionPerformed(evt);
            }
        });

        menuFile.add(menuExit);

        menuBarMain.add(menuFile);

        menuCommand.setText(java.util.ResourceBundle.getBundle("jp/maccreators/ostra/ggg4j/Resource").getString("menuCommand"));
        menuSearch.setText(java.util.ResourceBundle.getBundle("jp/maccreators/ostra/ggg4j/Resource").getString("menuSearch"));
        menuSearch.setActionCommand(java.util.ResourceBundle.getBundle("jp/maccreators/ostra/ggg4j/Resource").getString("menuSearch"));
        menuSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuSearchActionPerformed(evt);
            }
        });

        menuCommand.add(menuSearch);

        menuStop.setText(java.util.ResourceBundle.getBundle("jp/maccreators/ostra/ggg4j/Resource").getString("menuStop"));
        menuStop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuStopActionPerformed(evt);
            }
        });

        menuCommand.add(menuStop);

        menuBarMain.add(menuCommand);

        menuHelp.setText(java.util.ResourceBundle.getBundle("jp/maccreators/ostra/ggg4j/Resource").getString("menuHelp"));
        menuVersion.setText(java.util.ResourceBundle.getBundle("jp/maccreators/ostra/ggg4j/Resource").getString("menuVersion"));
        menuVersion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuVersionActionPerformed(evt);
            }
        });

        menuHelp.add(menuVersion);

        menuBarMain.add(menuHelp);

        setJMenuBar(menuBarMain);

        pack();
    }
    // </editor-fold>//GEN-END:initComponents

	private void menuVersionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuVersionActionPerformed
		JOptionPane.showMessageDialog(this, m_versionString);
	}//GEN-LAST:event_menuVersionActionPerformed

	/*
	 * ANV
	 */

	private void onTblResultMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_onTblResultMouseClicked
		if (evt.getClickCount() == 2) {
			menuOpenGraphicFileActionPerformed(null);
		}
	}//GEN-LAST:event_onTblResultMouseClicked

	private void menuOpenGraphicFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuOpenGraphicFileActionPerformed
		int n = tblResult.getSelectedRow();
		if (n < 0)
			return;
		TFileInfo info = (TFileInfo)m_hits.get(n);
		try {
			Runtime.getRuntime().exec(new String[] { m_setting.grephicViewer, info.m_filePath });
		}
		catch(Exception e) {
		}
	}//GEN-LAST:event_menuOpenGraphicFileActionPerformed
	
	private void onClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_onClosing
		m_gs.saveSetting(m_setting);
		Point p = getLocation();
		m_setting.locationX = p.x;
		m_setting.locationY = p.y;
		Dimension d = getSize(); 
		m_setting.windowHeight = (int)d.getHeight();
		m_setting.windowWidth = (int)d.getWidth();
		if (m_settingSaved == null || m_settingSaved.equals(m_setting) == false)
			m_setting.ending();
		m_gs.join();
		System.exit(0);
	}//GEN-LAST:event_onClosing
	
	private void btnSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSearchActionPerformed
		if (m_gs.isWorking())
			menuStopActionPerformed(null);
		else
			menuSearchActionPerformed(null);
	}//GEN-LAST:event_btnSearchActionPerformed
	
	private void menuStopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuStopActionPerformed
		m_gs.stop();
	}//GEN-LAST:event_menuStopActionPerformed
	
	private void menuSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuSearchActionPerformed
		if (m_gs.isWorking())
			return;
		TSearchDlg dlg = new TSearchDlg(this, false);
		dlg.setup(m_gs);
		if (dlg.doModal()) {
			m_hits.clear();
			tblResult.revalidate();
	        btnSearch.setText(java.util.ResourceBundle.getBundle(m_bundlePath).getString("btnStop"));
			m_gs.beginSearch();
		}
	}//GEN-LAST:event_menuSearchActionPerformed
	
	private void menuCreateIndexFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuCreateIndexFileActionPerformed
		if (m_gs.isWorking())
			return;
		TCreateIndexFileDlg dlg = new TCreateIndexFileDlg(this, true);
		dlg.setup(m_gs);
		if (dlg.doModal()) {
	        btnSearch.setText(java.util.ResourceBundle.getBundle(m_bundlePath).getString("btnStop"));
			m_gs.makeIndexFile();
		}
	}//GEN-LAST:event_menuCreateIndexFileActionPerformed
	
	private void menuExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuExitActionPerformed
		onClosing(null);
	}//GEN-LAST:event_menuExitActionPerformed
		
	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				JFrame w = new GGG4J();
				w.setVisible(true);
			}
		});
	}
	
    // ϐ錾 - ҏWs//GEN-BEGIN:variables
    private javax.swing.JButton btnSearch;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JMenuBar menuBarMain;
    private javax.swing.JMenu menuCommand;
    private javax.swing.JMenuItem menuCreateIndexFile;
    private javax.swing.JMenuItem menuExit;
    private javax.swing.JMenu menuFile;
    private javax.swing.JMenu menuHelp;
    private javax.swing.JMenuItem menuOpenGraphicFile;
    private javax.swing.JMenuItem menuSearch;
    private javax.swing.JMenuItem menuStop;
    private javax.swing.JMenuItem menuVersion;
    private javax.swing.JTextField msgCurrentFilePath;
    private javax.swing.JTable tblResult;
    // ϐ錾̏I//GEN-END:variables
	
}
