/*
 * TChunk.java
 *
 * Created on 2005/06/28
 * Copyright 2005 Takeshi Yoneki / OSTRA / OSTRACISM CO., All rights reserved.
 */

package jp.maccreators.ostra.ggg4j;

import java.io.InputStream;
import java.io.OutputStream;
import java.nio.ByteBuffer;

/**
 * TChunk `NNX
 * @author	ostra
 */
public class TChunk {
	public static final String CKID_HEAD = "GGHD";
	public static final String CKID_PATH = "GGPT";
	public static final String CKID_THUMB = "GGTM";
	
	public String m_ckID = "----";
	public int m_ckSize = 0;
	public ByteBuffer m_data = null;

	public TChunk() {
	}

	/**
	 * ǂݍ
	 */
	int read(InputStream stream) {
		if (stream == null)
			return 0;
		byte[] buff = new byte[4];
		try {
			if (stream.read(buff) != 4)
				return 0;
			m_ckID = new String(buff, 0, 4, "UTF-8");
			if (stream.read(buff) != 4)
				return 0;
			ByteBuffer bb = ByteBuffer.wrap(buff);
			m_ckSize = bb.getInt();
			m_data = ByteBuffer.allocate(m_ckSize);
			if (stream.read(m_data.array()) != m_ckSize)
				return 0;
		}
		catch(Exception e) {
			return 0;
		}
		return 8 + m_ckSize;
	}
	
	/**
	 * o
	 */
	int write(OutputStream stream) {
		if (stream == null)
			return 0;
		byte[] d = null;
		try {
			ByteBuffer bb = ByteBuffer.allocate(8);
			d = m_ckID.getBytes("UTF-8");
			if (d == null || d.length < 4)
				return 0;
			bb.put(d, 0, 4);
			m_ckSize = m_data.array().length;
			bb.putInt(m_ckSize);
			stream.write(bb.array(), 0, 8);
			stream.write(m_data.array());
		}
		catch (Exception e) {
			return 0;
		}
		return 8 + m_ckSize;
	}

}
