/*
 * TFileInfo.java
 *
 * Created on 2005/06/27
 * Copyright 2005 Takeshi Yoneki / OSTRA / OSTRACISM CO., All rights reserved.
 */

package jp.maccreators.ostra.ggg4j;

import java.awt.Color;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.lang.reflect.Array;
import javax.imageio.ImageIO;
import javax.swing.JFrame;

/**
 * TFileInfo 摜t@CNX
 * @author	ostra
 */
public class TFileInfo {
	public String m_filePath = "";
	public short[] m_thumbnail = null;
	public int m_thumbnailCount = 0;
	public int m_matchRate = 0; // v

	public TFileInfo() {
		super();
	}
	 
	public TFileInfo(String filePath) {
		super();
		m_filePath = filePath;
	}

	/**
	 * e狖e𓾂
	 */
	static int calcPardon(int thumbnailSize, int pardon) {
		return thumbnailSize * pardon / 100;
	}

	/**
	 * Tl[쐬
	 */
	public boolean makeThumbnail(int pixcelNumber) {
		if (m_filePath == null || m_filePath.length() == 0)
			return false;
		BufferedImage simg = null;
		try {
			simg = ImageIO.read(new File(m_filePath));
		}
		catch (Exception e) {
		}
		if (simg == null)
			return false;
		int height = pixcelNumber;
		int width = pixcelNumber;
		Image iimg = simg.getScaledInstance(width, height, Image.SCALE_AREA_AVERAGING);
		BufferedImage rimg = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
		rimg.getGraphics().drawImage(iimg, 0, 0, null);
		m_thumbnailCount = height * width;
		m_thumbnail = new short[m_thumbnailCount];
		int x, y;
		for (y = 0; y < height; y++) {
			for (x = 0; x < width; x++) {
				Color c = new Color(rimg.getRGB(x, y));
				int r = (c.getRed() >> 4);
				int g = (c.getGreen() >> 4);
				int b = (c.getBlue() >> 4);
				m_thumbnail[y * width + x] = (short)((r << 8) + (g << 4) + (b));
			}
		}
		return true;
	}
	
	/**
	 * Tl[r
	 */
	public boolean isEqualThumbnail(int bits, int matchRate, TFileInfo info) {
		if (m_thumbnailCount != info.m_thumbnailCount)
			return false;
		int pardonNumber = calcPardon(m_thumbnailCount, 100 - matchRate);
		int bad = 0;
		int i;
		for (i = 0; i < m_thumbnailCount; i++) {
			if (bad >= pardonNumber)
				return false;
			int r = ((m_thumbnail[i] >> 8) & 0xF);
			int g = ((m_thumbnail[i] >> 4) & 0xF);
			int b = ((m_thumbnail[i]) & 0xF);
			int ir = ((info.m_thumbnail[i] >> 8) & 0xF);
			int ig = ((info.m_thumbnail[i] >> 4) & 0xF);
			int ib = ((info.m_thumbnail[i]) & 0xF);
			int shift = 4 - bits;
			r >>= shift;
			g >>= shift;
			b >>= shift;
			ir >>= shift;
			ig >>= shift;
			ib >>= shift;
			if ((r == ir || r + 1 == ir || r - 1 == ir) &&
				(g == ig || g + 1 == ig || g - 1 == ig) &&
				(b == ib || b + 1 == ib || b - 1 == ib)) {
			}
			else {				
				bad++;
			}
		}

		info.m_matchRate = (m_thumbnailCount - bad) * 100 / m_thumbnailCount;
		return true;
	}

	/**
	 * 摜t@C`FbN
	 */
	public static boolean checkGraphicFile(String filePath) {
		TFileInfo info = new TFileInfo(filePath);
		boolean result = info.makeThumbnail(8);
		return result;
	}

}
