/*
 * TSetting.java
 *
 * Created on 2005/07/02, 17:04
 * Copyright 2005 Takeshi Yoneki / OSTRA / OSTRACISM CO., All rights reserved.
 */

package jp.maccreators.ostra.ggg4j;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;

/**
 * TSetting ݒۑNX
 * @author ostra
 */
public class TSetting {
	final static int CURRENT_PREF_VERSION = 0x100;

	String m_settingFilePath = "GGG4J.prop";
	
	public int version = CURRENT_PREF_VERSION;
	public int locationX = 100;
	public int locationY = 100;
	public int windowHeight = 200;
	public int windowWidth = 300;
	public String targetFilePath = "";
	public String topDirPath = "";
	public String indexFilePath = "";
	public int bits = 3;
	public int matchRate = 70;
	public int pixelNumber = 8;
	public int searchMethod = 0;
	public String grephicViewer = "";
	
	/** Creates a new instance of TSetting */
	public TSetting() {
	}

	/**
	 * f[^̃Rs[
	 */
	public void copyFrom(TSetting s) {
		version = s.version;
		locationX = s.locationX;
		locationY = s.locationY;
		windowHeight = s.windowHeight;
		windowWidth = s.windowWidth;
		targetFilePath = s.targetFilePath;
		topDirPath = s.topDirPath;
		indexFilePath = s.indexFilePath;
		bits = s.bits;
		matchRate = s.matchRate;
		pixelNumber = s.pixelNumber;
		searchMethod = s.searchMethod;
		grephicViewer = s.grephicViewer;
	}
	
	/**
	 * N[̍쐬
	 */
	public TSetting getClone() {
		TSetting s = new TSetting();
		s.copyFrom(this);
		return s;
	}

	/**
	 * r
	 */
	public boolean equals(TSetting s) {
		return (
			s.locationX == locationX &&
			s.locationY == locationY &&
			s.windowHeight == windowHeight &&
			s.windowWidth == windowWidth &&
			s.targetFilePath.equals(targetFilePath) &&
			s.topDirPath.equals(topDirPath) &&
			s.indexFilePath.equals(indexFilePath) &&
			s.bits == bits &&
			s.matchRate == matchRate &&
			s.pixelNumber == pixelNumber &&
			s.searchMethod == searchMethod &&
			s.grephicViewer.equals(grephicViewer)
		);
	}
	
	/**
	 * ݒ̓ǂݍ
	 */
	public boolean beginning() {
		File f = null;
		FileInputStream stream = null;
		try {
			f = new File(m_settingFilePath);
			if (f == null)
				return false;
				stream = new FileInputStream(f);
			if (stream == null)
				return false;
			Properties prop = new Properties();
			prop.load(stream);

			version = toInteger(prop.getProperty("version"), 0);
			if (version == 0) {
				version = CURRENT_PREF_VERSION;
				stream.close();
				return false;
			}

			locationX = toInteger(prop.getProperty("locationX"), locationX);
			locationY = toInteger(prop.getProperty("locationY"), locationY);
			windowHeight = toInteger(prop.getProperty("windowHeight"), windowHeight);
			windowWidth = toInteger(prop.getProperty("windowWidth"), windowWidth);
			targetFilePath = prop.getProperty("targetFilePath");
			topDirPath = prop.getProperty("topDirPath");
			indexFilePath = prop.getProperty("indexFilePath");
			bits = toInteger(prop.getProperty("bits"), bits);
			matchRate = toInteger(prop.getProperty("matchRate"), matchRate);
			pixelNumber = toInteger(prop.getProperty("pixelNumber"), pixelNumber);
			searchMethod = toInteger(prop.getProperty("searchMethod"), 0);
			grephicViewer = prop.getProperty("grephicViewer");
			version = CURRENT_PREF_VERSION;
		}
		catch (Exception e) {
			return false;
		}
		try {
			if (stream != null)
				stream.close();
		}
		catch (Exception e) {
		}
		return true;
	}

	/**
	 * ݒ̏o
	 */
	boolean ending() {
		File f = null;
		FileOutputStream stream = null;
		try {
			f = new File(m_settingFilePath);
			if (f == null)
				return false;
				stream = new FileOutputStream(f);
			if (stream == null)
				return false;
			Properties prop = new Properties();

			version = CURRENT_PREF_VERSION;
			prop.setProperty("version", String.valueOf(version));
			prop.setProperty("locationX", String.valueOf(locationX));
			prop.setProperty("locationY", String.valueOf(locationY));
			prop.setProperty("windowHeight", String.valueOf(windowHeight));
			prop.setProperty("windowWidth", String.valueOf(windowWidth));
			prop.setProperty("targetFilePath", targetFilePath);
			prop.setProperty("topDirPath", topDirPath);
			prop.setProperty("indexFilePath", indexFilePath);
			prop.setProperty("bits", String.valueOf(bits));
			prop.setProperty("matchRate", String.valueOf(matchRate));
			prop.setProperty("pixelNumber", String.valueOf(pixelNumber));
			prop.setProperty("searchMethod", String.valueOf(searchMethod));
			prop.setProperty("grephicViewer", grephicViewer);

			prop.store(stream, "GGG4J");
		}
		catch (Exception e) {
			return false;
		}
		try {
			if (stream != null)
				stream.close();
		}
		catch (Exception e) {
		}
		return true;

	}
	
	static int toInteger(String s, int defaultValue) {
		int n = defaultValue;
		try {
			n = Integer.parseInt(s);
		}
		catch (Exception e) {
		}
		return n;
	}
}
